
/*****************************************
#VectorDemo.cpp
#vector
#
#STL㷨
#lambadaʽ
#ָ
*******************************************/
#include "VectorDemo.h"
#include <vector>
#include <iostream>
#include <algorithm>
#include <memory>
#include "device.h"
#include <string>

using namespace std;
using namespace user;

void ShowInt(int &t)
{
	cout<<t<<" ";
}

bool CompareInt(int &t1, int &t2)
{
	if(t1<t2)
		return true;
	return false;
}

template<class T>
void show_sample_demo(vector<T> &v)
{
	// ָvector
	vector<T>::iterator itr;
	for(itr=v.begin(); itr!=v.end(); itr++)
	{
		cout<<*itr<<" ";
	}
	cout<<endl;
}

//vectorģ Ҫڻ
int sample_vector_Demo(void)
{
	//ʼ
	int a[5] = {rand()%100, rand()%100, rand()%100, rand()%100, rand()%100};
	vector<int> v0(a, a+5);
	vector<int> v1(v0);
	vector<int> v2(v0.begin(), v0.begin()+2);
	vector<int> v3(5);

	show_sample_demo<int>(v3); //0 0 0 0 0
	

	for_each(v2.begin(), v2.end(), [](int &iter){
		cout<<iter<<" ";
	});							//41 67
	cout<<endl;

	//for_eachб, ShowIntΪú
	for_each(v0.begin(), v0.end(), ShowInt);
	cout<<endl;				   //41 67 34 0 69
	
	//Ԫӵvectorĩβ
	v1.push_back(rand()%100);
	show_sample_demo<int>(v1); //41 67 34 0 69 24

	//
	sort(v1.begin(), v1.end(), CompareInt);
	show_sample_demo<int>(v1);	//0 24 34 41 67 69

	//vector 
	//lower_bound:زСԪֵĵһ(Ȼߴ)valueɱĵһλ
	//upper_bound:زƻ£valueɱһλ
	auto iter0 = lower_bound(v1.begin(), v1.end(), 34);
	cout<<*iter0<<endl;			//34
	iter0 = upper_bound(v1.begin(), v1.end(), 34);
	cout<<*iter0<<endl;			//41

	// ΪԶɴɲ
	random_shuffle(v1.begin(), v1.end(), [](const unsigned int n)-> unsigned int{
		return rand()%n;
	});
	//random_shuffle(v1.begin(), v1.end());
	show_sample_demo<int>(v1);	//34 0 41 24 67 69

	// lambadaʽ
	sort(v1.begin(), v1.end(), [](int &t1, int &t2)->bool{
		if(t1<t2)
			return true;
		return false;
	});
	show_sample_demo<int>(v1); //0 24 34 41 67 69

	//ɾvectorĩβԪ
	v1.pop_back();
	show_sample_demo<int>(v1); //0 24 34 41 67

	//size	   ǰԪظ
	//capacity ǰܹԪصĸ
	cout<<v1.size()<<endl;	  //5
	cout<<v1.capacity()<<endl;//7

	//ôС
	v1.reserve(14);
	v1.resize(9, 6);
	cout<<v1.size()<<endl;     //9
	cout<<v1.capacity()<<endl; //14

	//vectorַָ
	v1.insert(v1.begin(), a[0]);
	show_sample_demo(v1);	   //41 0 24 34 41 67 6 6 6 6
	v1.insert(v1.end(), a, a+2);
	show_sample_demo<int>(v1); //41 0 24 34 41 67 6 6 6 6 41 67 
	v1.insert(v1.end(), v0.begin()+2, v0.begin()+4);
	show_sample_demo<int>(v1); //41 0 24 34 41 67 6 6 6 6 41 67 34 0

	//жԪΪ
	if(!v1.empty())
	{
		v1.pop_back();
		cout<<"v1 is not empty!"<<endl; //v1 is not empty!
	}
	show_sample_demo<int>(v1); //41 0 24 34 41 67 6 6 6 6 41 67 34

	//ɾvectorָԪ
	v1.erase(v1.end()-6, v1.end());
	show_sample_demo<int>(v1); //41 0 24 34 41 67 6

	//vectorĵһλһλԪ
	cout<<v1.front()<<endl;		//41
	cout<<v1.back()<<endl;		//6

    //Ԫأapacity(ռڴδͷ)
	v1.clear();
	cout<<v1.size()<<endl;			//0
	cout<<v1.capacity()<<endl;		//14

	//vectorʵcapacitysize
	vector<int>().swap(v1);
	cout<<v1.size()<<endl;			//0
	cout<<v1.capacity()<<endl;		//0

	return 0;
}

template<class T>
void ShowDevice(T &s)
{
	cout<<*s;
}

template<class T>
void show_genericity_demo(vector<shared_ptr<device<T>>> &d)
{
	for(auto iter=d.begin(); iter!=d.end(); iter++)
	{
		cout<<**iter; //(*iter)->show_info();
	}
	cout<<endl;
}

template<class T>
bool genericity_compare(T &d1, T &d2)
{
	if((*d1) < (*d2))
		return true;
	else
		return false;
}

//vectorģ壬漰ָûԶ
int genericity_vector_Demo(void)
{
    shared_ptr<device<int>> spd[5] = {
        shared_ptr<device<int>>(new device<int>("TV", rand()%100)),
        shared_ptr<device<int>>(new device<int>("Phone", rand()%100)),
        shared_ptr<device<int>>(new device<int>("Computer", rand()%100)),
        shared_ptr<device<int>>(new device<int>("light", rand()%100)),
        shared_ptr<device<int>>(new device<int>("pot", rand()%100)),
    };
    
    //vectorͳʼΪdeviceӦָ
    vector<shared_ptr<device<int>>> vspd(spd, spd+5);
    
    //ʾvectorеж󣬴Ϊshared_ptrָ룬*ţͨ<< 
    for_each(vspd.begin(), vspd.end(), ShowDevice<shared_ptr<device<int>>>);
    cout<<endl;

    // lambadaʽ
     sort(vspd.begin(), vspd.end(), [](shared_ptr<device<int>> &t1, shared_ptr<device<int>> &t2)->bool{
            if((*t1)<(*t2))
                return true;
            return false;
        });

    //ڶ
    random_shuffle(vspd.begin(), vspd.end());
    show_genericity_demo<int>(vspd);

    cout<<*vspd.front()<<endl;
    cout<<*vspd.back()<<endl;

    vspd.push_back(shared_ptr<device<int>>(new device<int>("icebox", rand()%100)));
    vspd.push_back(shared_ptr<device<int>>(new device<int>("PlayStation", rand()%100)));
    
    //ΪԪΪָ룬֧ʡԱȽϺ
    sort(vspd.begin(), vspd.end(), genericity_compare<shared_ptr<device<int>>>);
    show_genericity_demo<int>(vspd);

    vspd.pop_back();
    show_genericity_demo<int>(vspd);

    // + ++أʵֶڶԪ޸.
    for_each(vspd.begin(), vspd.end(), [](shared_ptr<device<int>> &s){
        (*s) = (*s) + string("famlily ");
        (*s)++;
    });
    show_genericity_demo<int>(vspd);

    return 0;

	return 0;
}
